/******************************************************************************
 * @file      drv_qfc41d.h
 * @brief     drv_qfc41d.h
 * @version   V1.0
 * @author    Gary
 * @copyright
 ******************************************************************************/
#ifndef DRV_QFC41D_H_
#define DRV_QFC41D_H_

#include <stdio.h>
#include <stdint.h>
#include <stm32f4xx.h>
#include <string.h>
#include "drv_uart.h"
#include "kit_macro.h"
#include "ucos_ii.h"
#include "gpio_manager.h"
#include "kit_time.h"
#include "kit_debug.h"

#define QFC41D_UART_PORT     	kUartDev_2
#define QFC41D_MAX_SEND_SIZE    2048
#define QFC41D_MAX_RECV_SIZE    200
#define WIFI_TIMEOUT 100

#define QFC41D_RESTART_CMD "AT+QRST"
#define QFC41D_PING_CMD "AT+QPING=<IP>"
#define QFC41D_LOW_POWER_MODE "AT+QLOWPOWER"
#define QFC41D_GET_MACK_ADDR "AT+QWLMAC"
#define QFC41D_GET_WIFISTA_STATUS "AT+QSTAST"
#define QFC41D_SET_DHCP_ENABLE "AT+QSTADHCPDEF=1"

//ôڲ:AT+QSETBAND=<baud_rate>[,<save>]   <baud_rate> ,ڲʡ<save>ʡԸò򱣴沨ʡ0:沨 1:沨
#define QFC41D_SET_BATE "AT+QSETBAND=115200,1"



/* ģΪΧ豸ʱ GATT 
 * AT+QBLEGATTSNTFY=<UUID>[,<hex_lngth>],<data>
 * <UUID>	ַͣ˫ţֵ UUID ȣ2 ֽڻ 16 ֽڡ
 * <hex_length>	͡ʮݳȡʹøòʱģὫ<data>תΪʮٽ ͡磬<data>Ϊ 123456ģὫתΪ 0x123456 з͡
 * <data>	ַͣ˫ţGATT ݡ
 */
 
 
#define QFC41D_BLE_INIT "AT+QBLEINIT=2"

typedef void (*FC41DSendCall)(UartDev dev, uint8_t *buf, uint16_t len);

typedef struct
{
    uint8_t       dev;
    uint16_t      buf_pos;
	uint16_t      buf_size;
	uint8_t       *buf;
	FC41DSendCall sendCall;	
}WifiBleItem;

uint8_t drv_qfc41d_init(void);

// MQTT ʼ
uint8_t drv_mqtt_init();

//  MQTT Ϣ 
uint8_t drv_mqtt_publish(char* str,uint16_t length);

#endif //DRV_QFC41D_H_

